Index: branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/ArtificialDataDescriptor.cs
===================================================================
--- branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/ArtificialDataDescriptor.cs	(revision 14398)
+++ branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/ArtificialDataDescriptor.cs	(revision 14513)
@@ -1,13 +1,15 @@
-﻿using System.Collections.Generic;
-using HeuristicLab.Problems.Instances;
+﻿namespace HeuristicLab.BenchmarkSuite
+{
+  using System.Collections.Generic;
 
-namespace HeuristicLab.BenchmarkSuite
-{
-    public abstract class ArtificialDataDescriptor : IDataDescriptor
-    {
-        public abstract string Description { get; }
-        public abstract string Name { get; }
+  using HeuristicLab.Problems.Instances;
 
-        protected abstract IEnumerable<Example> GenerateExamples();
-    }
+  public abstract class ArtificialDataDescriptor : IDataDescriptor
+  {
+    public abstract string Description { get; }
+
+    public abstract string Name { get; }
+
+    protected abstract IEnumerable<Example> GenerateExamples();
+  }
 }
Index: branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/BenchmarkSuiteDataDescriptor.cs
===================================================================
--- branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/BenchmarkSuiteDataDescriptor.cs	(revision 14398)
+++ branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/BenchmarkSuiteDataDescriptor.cs	(revision 14513)
@@ -1,31 +1,33 @@
-﻿using System.Collections.Generic;
-using HeuristicLab.Core;
-using HeuristicLab.Random;
+﻿namespace HeuristicLab.BenchmarkSuite
+{
+  using System.Collections.Generic;
 
-namespace HeuristicLab.BenchmarkSuite
-{
-    public abstract class BenchmarkSuiteDataDescritpor<T> : ArtificialDataDescriptor
+  using HeuristicLab.Core;
+  using HeuristicLab.Random;
+
+  public abstract class BenchmarkSuiteDataDescritpor<T> : ArtificialDataDescriptor
+  {
+    protected static IRandom rand = new FastRandom();
+
+    protected abstract IEnumerable<T> GenerateTraining();
+
+    protected abstract IEnumerable<T> GenerateTest();
+
+    protected abstract IEnumerable<Example> GenerateExamples(IEnumerable<T> trainingAndTest);
+
+    protected override IEnumerable<Example> GenerateExamples()
     {
-        protected static IRandom rand = new FastRandom();
+      var training = this.GenerateTraining();
 
-        protected abstract IEnumerable<T> GenerateTraining();
-        protected abstract IEnumerable<T> GenerateTest();
+      training = training.Shuffle(rand);
 
-        protected abstract IEnumerable<Example> GenerateExamples(IEnumerable<T> trainingAndTest);
+      var test = this.GenerateTest();
 
-        protected override IEnumerable<Example> GenerateExamples()
-        {
-            var training = GenerateTraining();
+      var all = new List<T>();
+      all.AddRange(training);
+      all.AddRange(test);
 
-            training = training.Shuffle(rand);
-
-            var test = GenerateTest();
-
-            var all = new List<T>();
-            all.AddRange(training);
-            all.AddRange(test);
-
-            return GenerateExamples(all);
-        }
+      return this.GenerateExamples(all);
     }
+  }
 }
Index: branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/Example.cs
===================================================================
--- branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/Example.cs	(revision 14398)
+++ branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/Example.cs	(revision 14513)
@@ -1,8 +1,9 @@
 ﻿namespace HeuristicLab.BenchmarkSuite
 {
-    public class Example
-    {
-        public string Input { get; set; }
-        public string Output { get; set; }
-    }
+  public class Example
+  {
+    public string Input { get; set; }
+
+    public string Output { get; set; }
+  }
 }
Index: branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/HeuristicLab.BenchmarkSuite.csproj.user
===================================================================
--- branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/HeuristicLab.BenchmarkSuite.csproj.user	(revision 14513)
+++ branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/HeuristicLab.BenchmarkSuite.csproj.user	(revision 14513)
@@ -0,0 +1,6 @@
+﻿<?xml version="1.0" encoding="utf-8"?>
+<Project ToolsVersion="14.0" xmlns="http://schemas.microsoft.com/developer/msbuild/2003">
+  <PropertyGroup>
+    <ProjectView>ShowAllFiles</ProjectView>
+  </PropertyGroup>
+</Project>
Index: branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/Problems/CountOdds.cs
===================================================================
--- branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/Problems/CountOdds.cs	(revision 14398)
+++ branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/Problems/CountOdds.cs	(revision 14513)
@@ -1,145 +1,142 @@
-﻿using System;
-using System.Collections.Generic;
-using System.Linq;
+﻿namespace HeuristicLab.BenchmarkSuite.Problems
+{
+  using System.Collections.Generic;
+  using System.Linq;
 
-namespace HeuristicLab.BenchmarkSuite.Problems
-{
-    public class CountOdds : BenchmarkSuiteDataDescritpor<List<int>>
+  public class CountOdds : BenchmarkSuiteDataDescritpor<List<int>>
+  {
+    public const int MaxOdd = 999;
+
+    public const int MaxEven = 1000;
+
+    public const int MaxRandom = 1000;
+
+    public const int MinRandom = 1000;
+
+    public const int MaxVectorLength = 50;
+
+    public override string Description
     {
-        public const int MaxOdd = 999;
-        public const int MaxEven = 1000;
-        public const int MaxRandom = 1000;
-        public const int MinRandom = 1000;
-        public const int MaxVectorLength = 50;
+      get
+      {
+        return string.Empty;
+      }
+    }
 
-        public override string Description { get { return String.Empty; } }
+    public override string Name
+    {
+      get
+      {
+        return "Count Odds";
+      }
+    }
 
-        public override string Name { get { return "Count Odds"; } }
+    protected override IEnumerable<Example> GenerateExamples(IEnumerable<List<int>> inputData)
+    {
+      foreach (var input in inputData)
+        yield return
+          new Example
+            {
+              Input = string.Format("[{0}]", string.Join(", ", input)),
+              Output = input.Count(x => x % 2 == 1).ToString()
+            };
+    }
 
-        protected override IEnumerable<Example> GenerateExamples(IEnumerable<List<int>> inputData)
-        {
-            foreach (var input in inputData)
-            {
-                yield return new Example()
-                {
-                    Input = string.Format("[{0}]", string.Join(", ", input)),
-                    Output = input.Count(x => x % 2 == 1).ToString()
-                };
-            }
-        }
+    protected override IEnumerable<List<int>> GenerateTest()
+    {
+      foreach (var list in this.GetHardcodedTrainingSamples()) yield return list;
 
-        protected override IEnumerable<List<int>> GenerateTest()
-        {
-            foreach (var list in GetHardcodedTrainingSamples())
-                yield return list;
+      foreach (var list in this.GetAllOdd(100)) yield return list;
 
-            foreach (var list in GetAllOdd(n: 100))
-                yield return list;
+      foreach (var list in this.GetAllEven(100)) yield return list;
 
-            foreach (var list in GetAllEven(n: 100))
-                yield return list;
+      foreach (var list in this.GetRandom(1800)) yield return list;
+    }
 
-            foreach (var list in GetRandom(n: 1800))
-                yield return list;
-        }
+    protected override IEnumerable<List<int>> GenerateTraining()
+    {
+      foreach (var list in this.GetHardcodedTrainingSamples()) yield return list;
 
-        protected override IEnumerable<List<int>> GenerateTraining()
-        {
-            foreach (var list in GetHardcodedTrainingSamples())
-                yield return list;
+      foreach (var list in this.GetAllOdd(9)) yield return list;
 
-            foreach (var list in GetAllOdd(n: 9))
-                yield return list;
+      foreach (var list in this.GetAllEven(9)) yield return list;
 
-            foreach (var list in GetAllEven(n: 9))
-                yield return list;
+      foreach (var list in this.GetRandom(150)) yield return list;
+    }
 
-            foreach (var list in GetRandom(n: 150))
-                yield return list;
-        }
+    private IEnumerable<List<int>> GetAllOdd(int n)
+    {
+      for (var i = 0; i < n; i++)
+      {
+        var length = rand.Next(0, MaxVectorLength);
+        var vector = new List<int>(length);
 
-        private IEnumerable<List<int>> GetAllOdd(int n)
-        {
-            for (var i = 0; i < n; i++)
-            {
-                var length = rand.Next(0, MaxVectorLength);
-                var vector = new List<int>(length);
+        for (var j = 0; j < length; j++) vector.Add(rand.Next(0, MaxOdd) * 2 - MaxOdd);
 
-                for (var j = 0; j < length; j++)
-                {
-                    vector.Add(rand.Next(0, MaxOdd) * 2 - MaxOdd);
-                }
+        yield return vector;
+      }
+    }
 
-                yield return vector;
-            }
-        }
+    private IEnumerable<List<int>> GetAllEven(int n)
+    {
+      for (var i = 0; i < n; i++)
+      {
+        var length = rand.Next(0, MaxVectorLength);
+        var vector = new List<int>(length);
 
-        private IEnumerable<List<int>> GetAllEven(int n)
-        {
-            for (var i = 0; i < n; i++)
-            {
-                var length = rand.Next(0, MaxVectorLength);
-                var vector = new List<int>(length);
+        for (var j = 0; j < length; j++) vector.Add(rand.Next(0, MaxEven) * 2 - MaxEven);
 
-                for (var j = 0; j < length; j++)
-                {
-                    vector.Add(rand.Next(0, MaxEven) * 2 - MaxEven);
-                }
+        yield return vector;
+      }
+    }
 
-                yield return vector;
-            }
-        }
+    private IEnumerable<List<int>> GetRandom(int n)
+    {
+      for (var i = 0; i < n; i++)
+      {
+        var length = rand.Next(0, MaxVectorLength);
+        var vector = new List<int>(length);
 
-        private IEnumerable<List<int>> GetRandom(int n)
-        {
-            for (var i = 0; i < n; i++)
-            {
-                var length = rand.Next(0, MaxVectorLength);
-                var vector = new List<int>(length);
+        for (var j = 0; j < length; j++) vector.Add(rand.Next(MinRandom, MaxRandom));
 
-                for (var j = 0; j < length; j++)
-                {
-                    vector.Add(rand.Next(MinRandom, MaxRandom));
-                }
+        yield return vector;
+      }
+    }
 
-                yield return vector;
-            }
-        }
-
-        private IEnumerable<List<int>> GetHardcodedTrainingSamples()
-        {
-            yield return new List<int>() { };
-            yield return new List<int>() { -10 };
-            yield return new List<int>() { -9 };
-            yield return new List<int>() { -8 };
-            yield return new List<int>() { -7 };
-            yield return new List<int>() { -6 };
-            yield return new List<int>() { -5 };
-            yield return new List<int>() { -4 };
-            yield return new List<int>() { -3 };
-            yield return new List<int>() { -2 };
-            yield return new List<int>() { -1 };
-            yield return new List<int>() { -0 };
-            yield return new List<int>() { 1 };
-            yield return new List<int>() { 2 };
-            yield return new List<int>() { 3 };
-            yield return new List<int>() { 4 };
-            yield return new List<int>() { 5 };
-            yield return new List<int>() { 6 };
-            yield return new List<int>() { 7 };
-            yield return new List<int>() { 8 };
-            yield return new List<int>() { 9 };
-            yield return new List<int>() { 10 };
-            yield return new List<int>() { -947 };
-            yield return new List<int>() { -450 };
-            yield return new List<int>() { 303 };
-            yield return new List<int>() { 886 };
-            yield return new List<int>() { 0, 0 };
-            yield return new List<int>() { 0, 1 };
-            yield return new List<int>() { 7, 1 };
-            yield return new List<int>() { -9, -1 };
-            yield return new List<int>() { -11, 40 };
-            yield return new List<int>() { 944, 77 };
-        }
+    private IEnumerable<List<int>> GetHardcodedTrainingSamples()
+    {
+      yield return new List<int>();
+      yield return new List<int> { -10 };
+      yield return new List<int> { -9 };
+      yield return new List<int> { -8 };
+      yield return new List<int> { -7 };
+      yield return new List<int> { -6 };
+      yield return new List<int> { -5 };
+      yield return new List<int> { -4 };
+      yield return new List<int> { -3 };
+      yield return new List<int> { -2 };
+      yield return new List<int> { -1 };
+      yield return new List<int> { -0 };
+      yield return new List<int> { 1 };
+      yield return new List<int> { 2 };
+      yield return new List<int> { 3 };
+      yield return new List<int> { 4 };
+      yield return new List<int> { 5 };
+      yield return new List<int> { 6 };
+      yield return new List<int> { 7 };
+      yield return new List<int> { 8 };
+      yield return new List<int> { 9 };
+      yield return new List<int> { 10 };
+      yield return new List<int> { -947 };
+      yield return new List<int> { -450 };
+      yield return new List<int> { 303 };
+      yield return new List<int> { 886 };
+      yield return new List<int> { 0, 0 };
+      yield return new List<int> { 0, 1 };
+      yield return new List<int> { 7, 1 };
+      yield return new List<int> { -9, -1 };
+      yield return new List<int> { -11, 40 };
+      yield return new List<int> { 944, 77 };
     }
+  }
 }
Index: branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/Properties/AssemblyInfo.cs
===================================================================
--- branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/Properties/AssemblyInfo.cs	(revision 14398)
+++ branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/Properties/AssemblyInfo.cs	(revision 14513)
@@ -1,4 +1,3 @@
 ﻿using System.Reflection;
-using System.Runtime.CompilerServices;
 using System.Runtime.InteropServices;
 
@@ -6,4 +5,5 @@
 // set of attributes. Change these attribute values to modify the information
 // associated with an assembly.
+
 [assembly: AssemblyTitle("HeuristicLab.BenchmarkSuite")]
 [assembly: AssemblyDescription("")]
@@ -18,7 +18,9 @@
 // to COM components.  If you need to access a type in this assembly from 
 // COM, set the ComVisible attribute to true on that type.
+
 [assembly: ComVisible(false)]
 
 // The following GUID is for the ID of the typelib if this project is exposed to COM
+
 [assembly: Guid("22b5c087-cfc7-4d40-86c6-32fcf2ca921e")]
 
@@ -33,4 +35,5 @@
 // by using the '*' as shown below:
 // [assembly: AssemblyVersion("1.0.*")]
+
 [assembly: AssemblyVersion("1.0.0.0")]
 [assembly: AssemblyFileVersion("1.0.0.0")]